// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'anifile.pas' rev: 3.00

#ifndef anifileHPP
#define anifileHPP
#include <Menus.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <Messages.hpp>
#include <SysUtils.hpp>
#include <DsgnIntf.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <Graphics.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Anifile
{
//-- type declarations -------------------------------------------------------
typedef Byte ticonfile[766];

struct rtag
{
	char ckid[4];
	int cksize;
} ;

struct tAniHeader
{
	int cbSizeof;
	int cFrames;
	int cSteps;
	int cx;
	int cy;
	int cBitCount;
	int cPlanes;
	int jifRate;
	int fl;
} ;

struct ticondir
{
	Word reserved;
	Word cursortype;
	Word count;
} ;

struct ticonentry
{
	Byte width;
	Byte height;
	Byte colors;
	Byte rsrvd;
	Word hotspotx;
	Word hotspoty;
	int bytesinres;
	int imgoffset;
} ;

typedef int txormap[128];

typedef int tandmap[32];

typedef int tjifrates[128];

typedef int tsequences[128];

class DELPHICLASS TAniFile;
class PASCALIMPLEMENTATION TAniFile : public Graphics::TGraphic 
{
	typedef Graphics::TGraphic inherited;
	
private:
	HICON iconhandles[64];
	int jifrates[128];
	int sequences[128];
	tAniHeader aniheader;
	Classes::TMemoryStream* anistream;
	bool FHasData;
	int FCurFrame;
	int FJifCount;
	Classes::TNotifyEvent FOnChange;
	void __fastcall AniDecode(void);
	
protected:
	virtual void __fastcall Draw(Graphics::TCanvas* ACanvas, const Windows::TRect &Rect);
	virtual bool __fastcall GetEmpty(void);
	virtual int __fastcall GetHeight(void);
	virtual int __fastcall GetWidth(void);
	virtual void __fastcall SetHeight(int Value);
	virtual void __fastcall SetWidth(int Value);
	virtual void __fastcall ReadData(Classes::TStream* Stream);
	virtual void __fastcall WriteData(Classes::TStream* Stream);
	void __fastcall Step(void);
	void __fastcall SetFrame(int i);
	int __fastcall GetStreamSize(void);
	void __fastcall StreamToTemp(System::AnsiString filename);
	
public:
	__fastcall TAniFile(void);
	__fastcall virtual ~TAniFile(void);
	HIDESBASE void __fastcall Assign(TAniFile* Source);
	HIDESBASE void __fastcall LoadFromFile(const System::AnsiString FileName);
	virtual void __fastcall LoadFromStream(Classes::TStream* Stream);
	virtual void __fastcall SaveToStream(Classes::TStream* Stream);
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property bool HasData = {read=FHasData, write=FHasData, nodefault};
	int __fastcall GetCursorHandle(void);
};

class DELPHICLASS TAniIcon;
class PASCALIMPLEMENTATION TAniIcon : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	TAniFile* FAniFile;
	bool FAnimated;
	bool FTimerRun;
	int FTimerID;
	int FFrame;
	bool FTransparent;
	void __fastcall SetAniFile(TAniFile* newValue);
	void __fastcall SetAnimated(bool SetOn);
	void __fastcall SetFrame(int f);
	
protected:
	virtual void __fastcall Paint(void);
	HIDESBASE MESSAGE void __fastcall WMEraseBkGnd(Messages::TMessage &Message);
	MESSAGE void __fastcall WMTimer(Messages::TWMTimer &Msg);
	HIDESBASE MESSAGE void __fastcall WMDestroy(Messages::TMessage &Message);
	void __fastcall AniChanged(System::TObject* Sender);
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	
public:
	__fastcall virtual TAniIcon(Classes::TComponent* AOwner);
	__fastcall virtual ~TAniIcon(void);
	__property Canvas ;
	
__published:
	__property TAniFile* AniFile = {read=FAniFile, write=SetAniFile};
	__property bool Animated = {read=FAnimated, write=SetAnimated, nodefault};
	__property Align ;
	__property Color ;
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property int Frame = {read=FFrame, write=SetFrame, nodefault};
	__property ParentColor ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property Visible ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property bool Transparent = {read=FTransparent, write=FTransparent, nodefault};
public:
	/* TWinControl.CreateParented */ __fastcall TAniIcon(HWND ParentWindow) : Controls::TCustomControl(
		ParentWindow) { }
	
};

class DELPHICLASS TAniProperty;
class PASCALIMPLEMENTATION TAniProperty : public Dsgnintf::TClassProperty 
{
	typedef Dsgnintf::TClassProperty inherited;
	
public:
	virtual Dsgnintf::TPropertyAttributes __fastcall GetAttributes(void);
	virtual void __fastcall Edit(void);
	virtual void __fastcall SetValue(const System::AnsiString Value);
	virtual System::AnsiString __fastcall GetValue();
public:
	/* TPropertyEditor.Destroy */ __fastcall virtual ~TAniProperty(void) { }
	
public:
	/* TObject.Create */ __fastcall TAniProperty(void) : Dsgnintf::TClassProperty() { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE char cklist[4];
extern PACKAGE char ckicon[4];
extern PACKAGE char ckrate[4];
extern PACKAGE char ckseq[4];
#define crMyAniCursor (Word)(2000)

}	/* namespace Anifile */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Anifile;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// anifile
